using System.Linq.Expressions;

namespace DigitalData.Core.Application.Interfaces.Repository;

public interface IRepository<TEntity>
{
    public IEntityMapper<TEntity> Mapper { get; }

    public Task<TEntity> CreateAsync(TEntity entity, CancellationToken ct = default);

    public Task<IEnumerable<TEntity>> CreateAsync(IEnumerable<TEntity> entities, CancellationToken ct = default);
    
    public Task<IEnumerable<TEntity>> ReadAllAsync(Expression<Func<TEntity, bool>>? expression = null, CancellationToken ct = default);

    public Task<TEntity?> ReadOrDefaultAsync(Expression<Func<TEntity, bool>> expression, bool single = true, CancellationToken ct = default);

    public Task<IEnumerable<TDto>> ReadAllAsync<TDto>(Expression<Func<TEntity, bool>>? expression = null, CancellationToken ct = default);

    public Task<TDto?> ReadOrDefaultAsync<TDto>(Expression<Func<TEntity, bool>> expression, bool single = true, CancellationToken ct = default);

    public Task UpdateAsync<TDto>(TDto dto, Expression<Func<TEntity, bool>> expression, CancellationToken ct = default);

    public Task DeleteAsync(Expression<Func<TEntity, bool>> expression, CancellationToken ct = default);
}
